﻿#region CopyCode 
 
        /// <summary> 
        /// Script writed by Fix_Stv 
        /// you can modify or distribute script with indicating it's author 
        /// </summary> 
 
        IMyAirVent AirVent; 
        IMyDoor DoorSpace; 
        IMyDoor DoorRoom; 
        IMyTimerBlock Timer; 
        //IMyBlockGroup Indicators; 
        List<IMyInteriorLight> Lights; 
        List<IMyTextPanel> LCDs; 
        float fZero = 0f; 
        string LCDStatusText; 
        string NewLine = "\r\n"; 
        Color ColorFree; Color ColorPressureAction; Color ColorInitiateingProcedure; 
        bool WaitFotDoorRoomClose; 
        bool WaitForDoorSpaceClose; 
        bool SomeoneInside; 
        bool Pressurizing; 
        bool Depressurizing; 
		bool ShowPressurizingLevel; 
		float PressurizingLevel; 
 
        //Lang 
        clsTranslationItem StatusTitle = new clsTranslationItem("-----GATEWAY-----", "-----ШЛЮЗ-----"); 
        clsTranslationItem Status01 = new clsTranslationItem("Status", "Статус"); 
        clsTranslationItem StatusPressurizing = new clsTranslationItem("Pressurizing...", "Герметизация..."); 
        clsTranslationItem StatusDepressurizing = new clsTranslationItem("Depressurizing...", "Разгерметизация..."); 
        clsTranslationItem StatusWaitForDoorClose = new clsTranslationItem("Closing door...", "Закрытие двери..."); 
        clsTranslationItem StatusSequenceFree = new clsTranslationItem("Free to use", "Готово к использованию"); 
        clsTranslationItem StatusSequenceEnter = new clsTranslationItem("Initiated enter sequence", "Инициирована процедура входа"); 
        clsTranslationItem StatusSequenceExit = new clsTranslationItem("Initiated exit sequence", "Инициирована процедура выхода"); 
        //--Lang 
 
        //enum eCurrentSequence {Free=0, Enter, Exit}; 
        int CurrentSequence; 
 
        public Program() 
        { 
            //Lang 
            clsTranslationItem StatusAirVent = new clsTranslationItem("AirVent", "Вентиляция"); 
            clsTranslationItem StatusDoorSpace = new clsTranslationItem("Door space", "Дверь в космос"); 
            clsTranslationItem StatusDoorRoom = new clsTranslationItem("Door room", "Дверь в комнату"); 
            clsTranslationItem StatusTimer = new clsTranslationItem("Timer", "Таймер"); 
            clsTranslationItem StatusFound = new clsTranslationItem("Found", "Найдено"); 
            clsTranslationItem StatusNotFound = new clsTranslationItem("Not found", "Не найдено"); 
            clsTranslationItem KeyWordDoorSpace = new clsTranslationItem("space", "космос"); 
            clsTranslationItem KeyWordDoorRoom = new clsTranslationItem("room", "комнат"); 
            clsTranslationItem GroupGateway = new clsTranslationItem("Gateway", "Шлюз"); 
            clsTranslationItem GroupGatewayIndicators = new clsTranslationItem("GatewayIndicators", "ШлюзИндикаторы"); 
            //--Lang 
 
            //INPUT VALUES 
            clsTranslationItem.SetLanguage(1); // 0 = En; 1 = Ru 
			List<IMyTerminalBlock> GatewayBlocks = new List<IMyTerminalBlock>(); 
            GridTerminalSystem.GetBlockGroupWithName(GroupGateway.Text()).GetBlocks(GatewayBlocks); 
			List<IMyTerminalBlock> Indicators = new List<IMyTerminalBlock>(); 
            GridTerminalSystem.GetBlockGroupWithName(GroupGatewayIndicators.Text()).GetBlocks(Indicators); 
            ColorFree = new Color(0, 0, 0); 
            //ColorFree = new Color(0, 255, 0); 
            ColorPressureAction = new Color(255, 0, 0); 
            ColorInitiateingProcedure = new Color(255, 255, 0); 
			ShowPressurizingLevel = true; 
            //--INPUT VALUES 
 
            for (int i = 0; i < GatewayBlocks.Count; i++) 
            { 
                if (null == AirVent) 
                { 
                    if (GatewayBlocks[i] is IMyAirVent) AirVent = (GatewayBlocks[i] as IMyAirVent); 
                } 
 
                if (null == DoorSpace) 
                { 
                    if (GatewayBlocks[i] is IMyDoor) 
                    { 
                        if (GatewayBlocks[i].CustomName.ToLower().Contains(KeyWordDoorSpace.Text())) DoorSpace = (GatewayBlocks[i] as IMyDoor); 
                    } 
                } 
 
                if (null == DoorRoom) 
                { 
                    if (GatewayBlocks[i] is IMyDoor) 
                    { 
                        if (GatewayBlocks[i].CustomName.ToLower().Contains(KeyWordDoorRoom.Text())) DoorRoom = (GatewayBlocks[i] as IMyDoor); 
                    } 
                } 
 
                if (null == Timer) 
                { 
                    if (GatewayBlocks[i] is IMyTimerBlock) Timer = (GatewayBlocks[i] as IMyTimerBlock); 
                } 
 
            } 
 
            CurrentSequence = 0; 
 
            //Indicators 
            LCDStatusText = ""; 
            Lights = new List<IMyInteriorLight>(); 
            LCDs = new List<IMyTextPanel>(); 
            if (null != Indicators) 
            { 
                for (int i = 0; i < Indicators.Count; i++) 
                { 
                    IMyTerminalBlock CurrentBlock = Indicators[i]; 
                    if (CurrentBlock is IMyInteriorLight) 
                    { 
                        Lights.Add((CurrentBlock as IMyInteriorLight)); 
                    } 
                    if (CurrentBlock is IMyTextPanel) 
                    { 
                        LCDs.Add((CurrentBlock as IMyTextPanel)); 
                    } 
                } 
            } 
 
 
			SomeoneInside = false; 
			string StorageString = this.Storage; 
			if (StorageString.Length == 0) 
			{ 
				WaitFotDoorRoomClose = false; 
				WaitForDoorSpaceClose = false; 
				Pressurizing = false; 
				Depressurizing = false; 
			} 
			else 
			{ 
				WaitFotDoorRoomClose = GetBool(StorageString[0]); 
				WaitForDoorSpaceClose = GetBool(StorageString[1]); 
				Pressurizing = GetBool(StorageString[2]); 
				Depressurizing = GetBool(StorageString[3]); 
			} 
 
            Echo(StatusAirVent.Text() + " - " + Iif(AirVent is IMyAirVent, StatusFound.Text(), StatusNotFound.Text())); 
            Echo(StatusDoorRoom.Text() + " - " + Iif(DoorRoom is IMyDoor, StatusFound.Text(), StatusNotFound.Text())); 
            Echo(StatusDoorSpace.Text() + " - " + Iif(DoorSpace is IMyDoor, StatusFound.Text(), StatusNotFound.Text())); 
            Echo(StatusTimer.Text() + " - " + Iif(Timer is IMyTimerBlock, StatusFound.Text(), StatusNotFound.Text())); 
 
 
            for (int i = 0; i < LCDs.Count; i++) 
            { 
                LCDs[i].ShowPublicTextOnScreen(); 
            } 
 
            if (null != Timer) 
            { 
                if (Timer.GetValueBool("Silent") == false) Timer.SetValueBool("Silent", true); 
                Timer.SetValueFloat("TriggerDelay", 1f); 
            } 
 
            if (null != DoorSpace) 
            { 
                CloseDoor(DoorSpace); 
                OpenDoor(DoorRoom); 
                WaitForDoorSpaceClose = true; 
                Timer.ApplyAction("Start"); 
            } 
 
            SetLightsColor(ColorFree); 
        } 
 
        public void Main(string argument) 
        { 
			if ((Pressurizing || Depressurizing) && ShowPressurizingLevel) 
			{ 
				if (Pressurizing && PressurizingLevel >= 0.6f) 
				{ 
					argument = "OnPress"; 
				} 
				if (Depressurizing && PressurizingLevel == 0) 
				{ 
					argument = "OnDepress"; 
				} 
			} 
 
            switch (argument) 
            { 
                case "OnDepress": 
                    Depressurizing = false; 
                    switch (CurrentSequence) 
                    { 
                        case 0: 
                            break; 
                        case 1: 
                            OpenDoor(DoorSpace); 
                            break; 
                        case 2: 
                            OpenDoor(DoorSpace); 
                            break; 
                        default: 
                            break; 
                    } 
                    break; 
                case "OnPress": 
                    Pressurizing = false; 
                    switch (CurrentSequence) 
                    { 
                        case 0: 
                            break; 
                        case 1: 
                            if (SomeoneInside) OpenDoor(DoorRoom); 
                            break; 
                        case 2: 
                            if (!SomeoneInside) OpenDoor(DoorRoom); 
                            break; 
                        default: 
                            break; 
                    } 
                    break; 
                case "OnEnter": 
                    SomeoneInside = true; 
                    switch (CurrentSequence) 
	                { 
                        case 0: 
                            break; 
                        case 1: 
                            CloseDoor(DoorSpace); 
                            WaitForDoorSpaceClose = true; 
                            if (!Timer.IsCountingDown) Timer.ApplyAction("Start"); 
                            //Pressurize(AirVent); 
                            break; 
                        case 2: 
                            CloseDoor(DoorRoom); 
                            WaitFotDoorRoomClose = true; 
                            if (!Timer.IsCountingDown) Timer.ApplyAction("Start"); 
                            //DePressurize(AirVent); 
                            break; 
                        default: 
                            break; 
	                } 
                    break; 
                case "OnExit": 
                    SomeoneInside = false; 
                    switch (CurrentSequence) 
                    { 
                        case 0: 
                            break; 
                        case 1: 
                           CloseDoor(DoorRoom); 
                            CurrentSequence = 0; 
                            break; 
                        case 2: 
                            CloseDoor(DoorSpace); 
                            CurrentSequence = 0; 
                            break; 
                        default: 
                            break; 
                    } 
                    break; 
                case "Enter": 
                    switch (CurrentSequence) 
                    { 
                        case 0: 
                            CurrentSequence = 1; 
                            if (GetRoomPressure(AirVent) == fZero) 
                            { 
                                OpenDoor(DoorSpace); 
                            } 
                            else 
                            { 
                                LockDoor(DoorSpace); 
                                CloseDoor(DoorRoom); 
                                WaitFotDoorRoomClose = true; 
                                if (!Timer.IsCountingDown) Timer.ApplyAction("Start"); 
                                //DePressurize(AirVent); 
                            } 
                            break; 
                        case 1: 
                            break; 
                        case 2: 
                            if ((!SomeoneInside) && (!Pressurizing) && (!Depressurizing) && (!WaitForDoorSpaceClose) && (!WaitFotDoorRoomClose)) 
                            { 
                                CurrentSequence = 0; 
                                Main("Enter"); 
                                return; 
                            } 
                            break; 
                        default: 
                            break; 
                    } 
                    break; 
                case "Exit": 
                    switch (CurrentSequence) 
                    { 
                        case 0: 
                            CurrentSequence = 2; 
                            if (GetRoomPressure(AirVent) == fZero) 
                            { 
                                LockDoor(DoorRoom); 
                                CloseDoor(DoorSpace); 
                                WaitForDoorSpaceClose = true; 
                                if (!Timer.IsCountingDown) Timer.ApplyAction("Start"); 
                                //Pressurize(AirVent); 
                            } 
                            else 
                            { 
                                OpenDoor(DoorRoom); 
                            } 
                            break; 
                        case 1: 
                            if ((!SomeoneInside) && (!Pressurizing) && (!Depressurizing) && (!WaitForDoorSpaceClose) && (!WaitFotDoorRoomClose)) 
                            { 
                                CurrentSequence = 0; 
                                Main("Exit"); 
                                return; 
                            } 
                            break; 
                        case 2: 
                            break; 
                        default: 
                            break; 
                    } 
                    break; 
				//case "OnDoorClose": 
 
				//	break; 
                default: 
                    if (WaitFotDoorRoomClose) 
                    { 
                        if (DoorRoom.OpenRatio == fZero) 
                        { 
                            LockDoor(DoorRoom); 
                            DePressurize(AirVent); 
                            WaitFotDoorRoomClose = false; 
                        } 
                    } 
 
                    if (WaitForDoorSpaceClose) 
                    { 
                        if (DoorSpace.OpenRatio == fZero) 
                        { 
                            LockDoor(DoorSpace); 
                            Pressurize(AirVent); 
                            WaitForDoorSpaceClose = false; 
                        } 
                    } 
 
                    //if ((!WaitForDoorSpaceClose) && (!WaitFotDoorRoomClose)) Timer.ApplyAction("Stop"); else Timer.ApplyAction("Start"); 
					if (WaitFotDoorRoomClose || WaitForDoorSpaceClose) Timer.ApplyAction("TriggerNow"); 
					if ((Pressurizing || Depressurizing) && ShowPressurizingLevel) Timer.ApplyAction("TriggerNow"); 
                    break; 
            } //--Switch Argument 
            ShowStatus(); 
        } 
		 
		public bool GetBool(char parameter) 
		{ 
			if (parameter == '1') return true; else return false; 
		} 
 
		public string GetBool(bool parameter) 
		{ 
			if (parameter) return "1"; else return "0"; 
		} 
 
		public void Save() 
		{ 
			StringBuilder Res = new StringBuilder(); 
			Res.Append(GetBool(WaitFotDoorRoomClose)); 
			Res.Append(GetBool(WaitForDoorSpaceClose)); 
			Res.Append(GetBool(Pressurizing)); 
			Res.Append(GetBool(Depressurizing)); 
 
			//this.Storage = Iif(WaitFotDoorRoomClose = true , "1", "0"); 
		} 
 
        void OpenDoor(IMyDoor pDoor) 
        { 
            UnlockDoor(pDoor); 
            pDoor.ApplyAction("Open_On"); 
        } 
 
        void CloseDoor(IMyDoor pDoor) 
        { 
            pDoor.ApplyAction("Open_Off"); 
        } 
 
        void LockDoor(IMyDoor pDoor) 
        { 
            pDoor.ApplyAction("OnOff_Off"); 
        } 
 
        void UnlockDoor(IMyDoor pDoor) 
        { 
            pDoor.ApplyAction("OnOff_On"); 
        } 
 
        void Pressurize(IMyAirVent pAirVent) 
        { 
            if (pAirVent.GetValueBool("Depressurize") == true) 
            { 
                Pressurizing = true; 
            } 
            pAirVent.ApplyAction("Depressurize_Off"); 
        } 
 
        void DePressurize(IMyAirVent pAirVent) 
        { 
            Depressurizing = true; 
            pAirVent.ApplyAction("Depressurize_On"); 
        } 
 
        float GetRoomPressure(IMyAirVent pAirVent) 
        { 
            if (AirVent.CanPressurize) 
            { 
				PressurizingLevel = pAirVent.GetOxygenLevel(); 
				return PressurizingLevel * 100; 
				//int StartInd = pAirVent.DetailedInfo.LastIndexOf("re: ") + 4; 
				//int LastInd = pAirVent.DetailedInfo.LastIndexOf("%"); 
				//if (LastInd <= 0) return fZero; 
 
				//try 
				//{ 
				//	return float.Parse(pAirVent.DetailedInfo.Substring(StartInd, LastInd - StartInd)); 
				//} 
				//catch (Exception) 
				//{ 
				//	return fZero; 
				//	//throw; 
				//} 
            } 
            return fZero; 
        } 
 
        public struct clsTranslationItem 
        { 
            private static int Language; 
 
            public string English; 
            public string Russian; 
 
            public clsTranslationItem(string pEngilsh, string pRussian) 
            { 
                English = pEngilsh; 
                Russian = pRussian; 
            } 
 
            public static void SetLanguage(int pLanguage) 
            { 
                Language = pLanguage; 
            } 
 
            public String Text() 
            { 
                switch (Language) 
                { 
                    case 0: 
                        return English; 
                    case 1: 
                        return Russian; 
                    default: 
                        return ""; 
                } 
            } 
        } 
 
        public static object Iif(bool cond, object truepart, object falsepart) 
        { 
            return cond ? truepart : falsepart; 
        } 
 
        public void ShowStatus() 
        { 
            if (LCDs.Count == 0) return; 
 
            LCDStatusText = StatusTitle.Text() + NewLine + Status01.Text(); 
            switch (CurrentSequence) 
            { 
                case 0: 
                    SetLightsColor(ColorFree); 
                    LCDStatusText += NewLine + StatusSequenceFree.Text(); 
                    break; 
                case 1: 
                    SetLightsColor(ColorInitiateingProcedure); 
                    LCDStatusText += NewLine + StatusSequenceEnter.Text(); 
                    break; 
                case 2: 
                    SetLightsColor(ColorInitiateingProcedure); 
                    LCDStatusText += NewLine + StatusSequenceExit.Text(); 
                    break; 
                default: 
                    break; 
            } 
 
            if (Pressurizing) LCDStatusText += NewLine + StatusPressurizing.Text(); 
            if (Depressurizing) LCDStatusText += NewLine + StatusDepressurizing.Text(); 
 
			if ((Pressurizing) || (Depressurizing)) 
			{ 
				SetLightsColor(ColorPressureAction); 
				if (ShowPressurizingLevel) LCDStatusText += " " + GetRoomPressure(AirVent).ToString("0.00") + "%"; 
			} 
 
            if ((WaitForDoorSpaceClose) || (WaitFotDoorRoomClose)) LCDStatusText += NewLine + StatusWaitForDoorClose.Text(); 
            for (int i = 0; i < LCDs.Count; i++) 
            { 
                LCDs[i].WritePublicText(LCDStatusText); 
            } 
        } 
 
        public void SetLightsColor(Color pColor) 
        { 
            if (Lights.Count == 0) return; 
 
            for (int i = 0; i < Lights.Count; i++) 
            { 
                Lights[i].SetValueColor("Color", pColor); 
            } 
        } 
 
        //public void ShowStatus(string pString, bool pNewLine = true, bool pAppend = true) 
        //{ 
        //    if (LCDs.Count == 0) return; 
        //    if (!pAppend) LCDStatusText = ""; 
        //    if (pNewLine) LCDStatusText += NewLine; 
        //    LCDStatusText += pString; 
 
        //    for (int i = 0; i < LCDs.Count; i++) 
        //    { 
        //        LCDs[i].WritePublicText(LCDStatusText); 
        //    } 
        //} 
 
#endregion 
